Index: TOOLS/WATER_BUDGET/OCE_waterbudget.py
===================================================================
--- TOOLS/WATER_BUDGET/OCE_waterbudget.py	(revision 6620)
+++ TOOLS/WATER_BUDGET/OCE_waterbudget.py	(revision 6647)
@@ -39,4 +39,6 @@
 import nemo, lmdz
 
+from WaterUtils import VarInt, Rho, Ra, Grav, ICE_rho_ice, ICE_rho_sno, OCE_rho_liq, ATM_rho, SRF_rho, RUN_rho, ICE_rho_pnd, YearLength
+
 ## Creates parser for reading .ini input file
 ## -------------------------------------------
@@ -47,6 +49,7 @@
 ## ---------------------
 ATM=None ; ATM_HIS='latlon' ; SRF_HIS='latlon' ; RUN_HIS='latlon' ; ORCA=None ; NEMO=None ; OCE_relax=False
-OCE_icb=False ; Coupled=False ; Routing=None
+OCE_icb=False ; Coupled=False ; Routing=None ; TestInterp=None
 TarRestartPeriod_beg=None ; TarRestartPeriod_end=None ; Comment=None ; Period=None ; Title=None
+YearBegin=None ; YearEnd=None ; DateBegin=None ; DateEnd=None
 
 ##
@@ -66,4 +69,11 @@
 tar_restart_end_RUN=None ; tar_restart_end_OCE=None ; tar_restart_end_ICE=None
 ContinueOnError=False ; ErrorCount=0 ; SortIco = False
+
+##
+## Precision of history file reading
+## ---------------------------------
+# Default is float (full precision). Degrade the precision by using np.float32
+# Restart file are always read at the full precision
+readPrec=float
 
 ## Read command line arguments
@@ -137,5 +147,14 @@
 
 print ( f'\nConfig file readed : {IniFile} ' )
-            
+
+##
+## Reading prec
+if wu.unDefined ( 'readPrec' )  :
+    readPrec = np.float64
+else :
+    if readPrec in ["float", "float64", "r8", "double", "<class 'float'>"         ] : readPrec = float
+    if readPrec in [         "float32", "r4", "single", "<class 'numpy.float32'>" ] : readPrec = np.float32
+    if readPrec in [         "float16", "r2", "half"  , "<class 'numpy.float16'>" ] : readPrec = np.float16
+              
 ## Some physical constants
 ## =======================
@@ -155,8 +174,8 @@
 if not 'Files' in config.keys () : config['Files'] = {}
 
-config['Physics'] = { 'Ra':Ra, 'Grav':Grav, 'ICE_rho_ice':ICE_rho_ice, 'ICE_rho_sno':ICE_rho_sno,
-                      'OCE_rho_liq':OCE_rho_liq, 'ATM_rho':ATM_rho, 'SRF_rho':SRF_rho, 'RUN_rho':RUN_rho}
-
-config['Config'] = { 'ContinueOnError':ContinueOnError, 'SortIco':SortIco }
+config['Physics'] = { 'Ra':str(Ra), 'Grav':str(Grav), 'ICE_rho_ice':str(ICE_rho_ice), 'ICE_rho_sno':str(ICE_rho_sno),
+                      'OCE_rho_liq':str(OCE_rho_liq), 'ATM_rho':str(ATM_rho), 'SRF_rho':str(SRF_rho), 'RUN_rho':str(RUN_rho)}
+
+config['Config'] = { 'ContinueOnError':ContinueOnError, 'SortIco':SortIco, 'TestInterp':str(TestInterp), 'readPrec':str(readPrec) }
 
 ## --------------------------
@@ -178,14 +197,15 @@
     config['Experiment']['DateBegin'] = DateBegin
 else :
-    YearBegin, MonthBegin, DayBegin = wu.DateSplit ( DateBegin )
+    YearBegin, MonthBegin, DayBegin = wu.SplitDate ( DateBegin )
     DateBegin = wu.FormatToGregorian ( DateBegin)
-    config['Experiment']['YearBegin'] = YearBegin
+    config['Experiment']['YearBegin'] = str(YearBegin)
 
 if wu.unDefined ( 'DateEnd' )   :
     DateEnd   = f'{YearEnd}1231'
-    config['Experiment']['DateEnd']   = DateEnd
+    config['Experiment']['DateEnd']   = str(DateEnd)
 else :
-    YearEnd, MonthEnd, DayEnd = wu.DateSplit ( DateEnd )
+    YearEnd, MonthEnd, DayEnd = wu.SplitDate ( DateEnd )
     DateEnd   = wu.FormatToGregorian ( DateEnd)
+    config['Experiment']['DateEnd']   = str(DateEnd)
 
 if wu.unDefined ( 'PackFrequency' ) :
@@ -204,6 +224,10 @@
 ## Output file with water budget diagnostics
 ## -----------------------------------------
-if wu.unDefined ( 'FileOut' ) : FileOut = f'ATM_waterbudget_{JobName}_{DateBegin}_{DateEnd}.out'
-config['Files']['FileOut'] = FileOut
+if wu.unDefined ( 'FileOut' ) :
+    FileOut = f'OCE_waterbudget_{JobName}_{YearBegin}_{YearEnd}'
+    if readPrec == np.float32 : FileOut = f'{FileOut}_float32'
+    FileOut = f'{FileOut}.out'
+
+    config['Files']['FileOut'] = FileOut
 
 f_out = open ( FileOut, mode = 'w' )
@@ -211,17 +235,24 @@
 ## Useful functions
 ## ----------------
-def kg2Sv  (val, rho=OCE_rho_liq) :
+
+# Degrades precision 
+if readPrec == float :
+    def rprec (tab) : return tab
+else : 
+    def rprec (tab) : return tab.astype(readPrec).astype(float)
+        
+def kg2Sv  (val, rho=ATM_rho) :
     '''From kg to Sverdrup'''
     return val/dtime_sec*1.0e-6/rho
 
-def kg2myear (val, rho=OCE_rho_liq) :
+def kg2myear (val, rho=ATM_rho) :
     '''From kg to m/year'''
     return val/OCE_aire_tot/rho/NbYear
 
-def var2prt (var, small=False, rho=OCE_rho_liq) :
+def var2prt (var, small=False, rho=ATM_rho) :
     if small :  return var , kg2Sv(var, rho=rho)*1000., kg2myear(var, rho=rho)*1000.
     else     :  return var , kg2Sv(var, rho=rho)      , kg2myear(var, rho=rho)
 
-def prtFlux (Desc, var, Form='F', small=False, rho=OCE_rho_liq, width=15) :
+def prtFlux (Desc, var, Form='F', small=False, rho=ATM_rho, width=15) :
     if small :
         if Form in ['f', 'F'] : ff=" {:14.6e} kg | {:12.4f} mSv | {:12.4f} mm/year "
@@ -330,7 +361,7 @@
 if NEMO == 3.6 :d_ICE_his = d_ICE_his.rename ( {'y_grid_T':'y', 'x_grid_T':'x'} )
 
-echo ( file_OCE_his )
-echo ( file_OCE_sca )
-echo ( file_ICE_his )
+echo ( f'{file_OCE_his = }' )
+echo ( f'{file_OCE_sca = }' )
+echo ( f'{file_ICE_his = }' )
 
 ## Compute run length
@@ -666,48 +697,48 @@
 
 # Read variable and computes integral over space and time
-OCE_empmr      = d_OCE_his['wfo']         ; OCE_mas_empmr    = OCE_flux_int ( OCE_empmr    )
-OCE_wfob       = d_OCE_his['wfob']        ; OCE_mas_wfob     = OCE_flux_int ( OCE_wfob     )
-OCE_emp_oce    = d_OCE_his['emp_oce']     ; OCE_mas_emp_oce  = OCE_flux_int ( OCE_emp_oce  )
-OCE_emp_ice    = d_OCE_his['emp_ice']     ; OCE_mas_emp_ice  = OCE_flux_int ( OCE_emp_ice  )
-OCE_iceshelf   = d_OCE_his['iceshelf']    ; OCE_mas_iceshelf = OCE_flux_int ( OCE_iceshelf )
-OCE_calving    = d_OCE_his['calving']     ; OCE_mas_calving  = OCE_flux_int ( OCE_calving  )
-OCE_iceberg    = d_OCE_his['iceberg']     ; OCE_mas_iceberg  = OCE_flux_int ( OCE_iceberg  )
-OCE_friver     = d_OCE_his['friver']      ; OCE_mas_friver   = OCE_flux_int ( OCE_friver   )
-OCE_runoffs    = d_OCE_his['runoffs']     ; OCE_mas_runoffs  = OCE_flux_int ( OCE_runoffs  )
+OCE_empmr      = rprec (d_OCE_his['wfo']     )    ; OCE_mas_empmr    = OCE_flux_int ( OCE_empmr    )
+OCE_wfob       = rprec (d_OCE_his['wfob']    )    ; OCE_mas_wfob     = OCE_flux_int ( OCE_wfob     )
+OCE_emp_oce    = rprec (d_OCE_his['emp_oce'] )    ; OCE_mas_emp_oce  = OCE_flux_int ( OCE_emp_oce  )
+OCE_emp_ice    = rprec (d_OCE_his['emp_ice'] )    ; OCE_mas_emp_ice  = OCE_flux_int ( OCE_emp_ice  )
+OCE_iceshelf   = rprec (d_OCE_his['iceshelf'])    ; OCE_mas_iceshelf = OCE_flux_int ( OCE_iceshelf )
+OCE_calving    = rprec (d_OCE_his['calving'] )    ; OCE_mas_calving  = OCE_flux_int ( OCE_calving  )
+OCE_iceberg    = rprec (d_OCE_his['iceberg'] )    ; OCE_mas_iceberg  = OCE_flux_int ( OCE_iceberg  )
+OCE_friver     = rprec (d_OCE_his['friver']  )    ; OCE_mas_friver   = OCE_flux_int ( OCE_friver   )
+OCE_runoffs    = rprec (d_OCE_his['runoffs'] )    ; OCE_mas_runoffs  = OCE_flux_int ( OCE_runoffs  )
 if NEMO == 4.0 or NEMO == 4.2 :
-    OCE_wfxice     = d_OCE_his['vfxice'] ; OCE_mas_wfxice   = OCE_flux_int ( OCE_wfxice )
-    OCE_wfxsnw     = d_OCE_his['vfxsnw'] ; OCE_mas_wfxsnw   = OCE_flux_int ( OCE_wfxsnw )
-    OCE_wfxsub     = d_OCE_his['vfxsub'] ; OCE_mas_wfxsub   = OCE_flux_int ( OCE_wfxsub )
+    OCE_wfxice     = rprec (d_OCE_his['vfxice']) ; OCE_mas_wfxice   = OCE_flux_int ( OCE_wfxice )
+    OCE_wfxsnw     = rprec (d_OCE_his['vfxsnw']) ; OCE_mas_wfxsnw   = OCE_flux_int ( OCE_wfxsnw )
+    OCE_wfxsub     = rprec (d_OCE_his['vfxsub']) ; OCE_mas_wfxsub   = OCE_flux_int ( OCE_wfxsub )
 if NEMO == 3.6 :
-    OCE_wfxice     = d_OCE_his['vfxice']/86400.*ICE_rho_ice ; OCE_mas_wfxice   = OCE_flux_int ( OCE_wfxice )
-    OCE_wfxsnw     = d_OCE_his['vfxsnw']/86400.*ICE_rho_sno ; OCE_mas_wfxsnw   = OCE_flux_int ( OCE_wfxsnw )
-    OCE_wfxsub     = d_OCE_his['vfxsub']/86400.*ICE_rho_sno ; OCE_mas_wfxsub   = OCE_flux_int ( OCE_wfxsub )
+    OCE_wfxice     = rprec (d_OCE_his['vfxice'])/86400.*ICE_rho_ice ; OCE_mas_wfxice   = OCE_flux_int ( OCE_wfxice )
+    OCE_wfxsnw     = rprec (d_OCE_his['vfxsnw'])/86400.*ICE_rho_sno ; OCE_mas_wfxsnw   = OCE_flux_int ( OCE_wfxsnw )
+    OCE_wfxsub     = rprec (d_OCE_his['vfxsub'])/86400.*ICE_rho_sno ; OCE_mas_wfxsub   = OCE_flux_int ( OCE_wfxsub )
 # Additional checks
-OCE_evap_oce   = d_OCE_his['evap_ao_cea'] ; OCE_mas_evap_oce   = OCE_flux_int ( OCE_evap_oce )
-ICE_evap_ice   = d_OCE_his['subl_ai_cea'] ; ICE_mas_evap_ice   = OCE_flux_int ( ICE_evap_ice )
-OCE_snow_oce   = d_OCE_his['snow_ao_cea'] ; OCE_mas_snow_oce   = OCE_flux_int ( OCE_snow_oce )
-OCE_snow_ice   = d_OCE_his['snow_ai_cea'] ; OCE_mas_snow_ice   = OCE_flux_int ( OCE_snow_ice )
-OCE_rain       = d_OCE_his['rain']        ; OCE_mas_rain       = OCE_flux_int ( OCE_rain     )
-ICE_wfxsub_err = d_ICE_his['vfxsub_err']  ; ICE_mas_wfxsub_err = OCE_flux_int ( ICE_wfxsub_err )
+OCE_evap_oce   = rprec (d_OCE_his['evap_ao_cea']) ; OCE_mas_evap_oce   = OCE_flux_int ( OCE_evap_oce )
+ICE_evap_ice   = rprec (d_OCE_his['subl_ai_cea']) ; ICE_mas_evap_ice   = OCE_flux_int ( ICE_evap_ice )
+OCE_snow_oce   = rprec (d_OCE_his['snow_ao_cea']) ; OCE_mas_snow_oce   = OCE_flux_int ( OCE_snow_oce )
+OCE_snow_ice   = rprec (d_OCE_his['snow_ai_cea']) ; OCE_mas_snow_ice   = OCE_flux_int ( OCE_snow_ice )
+OCE_rain       = rprec (d_OCE_his['rain']       ) ; OCE_mas_rain       = OCE_flux_int ( OCE_rain     )
+ICE_wfxsub_err = rprec (d_ICE_his['vfxsub_err'] ) ; ICE_mas_wfxsub_err = OCE_flux_int ( ICE_wfxsub_err )
 if NEMO == 4.0 or NEMO == 4.2 :
-    ICE_wfxpnd     = d_ICE_his['vfxpnd']     ; ICE_mas_wfxpnd     = OCE_flux_int ( ICE_wfxpnd     )
-    ICE_wfxsnw_sub = d_ICE_his['vfxsnw_sub'] ; ICE_mas_wfxsnw_sub = OCE_flux_int ( ICE_wfxsnw_sub )
-    ICE_wfxsnw_pre = d_ICE_his['vfxsnw_pre'] ; ICE_mas_wfxsnw_pre = OCE_flux_int ( ICE_wfxsnw_pre )
+    ICE_wfxpnd     = rprec (d_ICE_his['vfxpnd']    ) ; ICE_mas_wfxpnd     = OCE_flux_int ( ICE_wfxpnd     )
+    ICE_wfxsnw_sub = rprec (d_ICE_his['vfxsnw_sub']) ; ICE_mas_wfxsnw_sub = OCE_flux_int ( ICE_wfxsnw_sub )
+    ICE_wfxsnw_pre = rprec (d_ICE_his['vfxsnw_pre']) ; ICE_mas_wfxsnw_pre = OCE_flux_int ( ICE_wfxsnw_pre )
 if NEMO == 3.6 :
     ICE_wfxpnd = 0.0 ; ICE_mas_wfxpnd = 0.0
-    ICE_wfxsnw_sub = d_ICE_his['vfxsub']/86400.*ICE_rho_sno  ; ICE_mas_wfxsnw_sub = OCE_flux_int ( ICE_wfxsnw_sub )
-    ICE_wfxsnw_pre = d_ICE_his['vfxspr']/86400.*ICE_rho_sno  ; ICE_mas_wfxsnw_pre = OCE_flux_int ( ICE_wfxsnw_pre     )
-
-OCE_wfcorr    = d_OCE_his['wfcorr'] ; OCE_mas_wfcorr  = OCE_flux_int ( OCE_wfcorr )
+    ICE_wfxsnw_sub = rprec (d_ICE_his['vfxsub'])/86400.*ICE_rho_sno  ; ICE_mas_wfxsnw_sub = OCE_flux_int ( ICE_wfxsnw_sub )
+    ICE_wfxsnw_pre = rprec (d_ICE_his['vfxspr'])/86400.*ICE_rho_sno  ; ICE_mas_wfxsnw_pre = OCE_flux_int ( ICE_wfxsnw_pre     )
+
+OCE_wfcorr    = rprec (d_OCE_his['wfcorr']) ; OCE_mas_wfcorr  = OCE_flux_int ( OCE_wfcorr )
 if OCE_relax  :
     # ssr and fwb are included in emp=>empmr but not in emp_oce (outputed by sea-ice)
-    OCE_vflx_fwb = d_OCE_his['vflx_fwb'] ; OCE_mas_vflx_fwb   = OCE_flux_int ( OCE_vflx_fwb )
-    OCE_vflx_ssr = d_OCE_his['vflx_ssr'] ; OCE_mas_vflx_ssr   = OCE_flux_int ( OCE_vflx_ssr )
+    OCE_vflx_fwb = rprec (d_OCE_his['vflx_fwb']) ; OCE_mas_vflx_fwb   = OCE_flux_int ( OCE_vflx_fwb )
+    OCE_vflx_ssr = rprec (d_OCE_his['vflx_ssr']) ; OCE_mas_vflx_ssr   = OCE_flux_int ( OCE_vflx_ssr )
 else : 
     OCE_fwb = 0.0 ; OCE_mas_fwb = 0.0
     OCE_ssr = 0.0 ; OCE_mas_ssr = 0.0
 if OCE_icb :
-    OCE_berg_icb    = d_OCE_his['berg_floating_melt'] ; OCE_mas_berg_icb = OCE_flux_int ( OCE_berg_icb    )
-    OCE_calving_icb = d_OCE_his['calving_icb']        ; OCE_mas_calv_icb = OCE_flux_int ( OCE_calving_icb )
+    OCE_berg_icb    = rprec (d_OCE_his['berg_floating_melt']) ; OCE_mas_berg_icb = OCE_flux_int ( OCE_berg_icb    )
+    OCE_calving_icb = rprec (d_OCE_his['calving_icb']       ) ; OCE_mas_calv_icb = OCE_flux_int ( OCE_calving_icb )
 else :
     OCE_berg_icb = 0. ; OCE_mas_berg_icb = 0.
@@ -715,6 +746,5 @@
 
 OCE_mas_emp = OCE_mas_emp_oce - OCE_mas_wfxice - OCE_mas_wfxsnw - ICE_mas_wfxpnd - ICE_mas_wfxsub_err
-
-OCE_mas_all = OCE_mas_emp_oce +OCE_mas_emp_ice - OCE_mas_runoffs - OCE_mas_iceshelf
+OCE_mas_all = OCE_mas_emp_oce + OCE_mas_emp_ice - OCE_mas_runoffs - OCE_mas_iceshelf
 
 echo ('\n-- Fields:' ) 
@@ -748,4 +778,11 @@
 prtFlux ('  CALV_ICB     ', OCE_mas_calv_icb  , 'e', True)
 
+echo (' ')
+if Coupled :
+    prtFlux ( 'Bilan ocean :', -OCE_mas_emp_oce - OCE_mas_emp_ice + OCE_mas_runoffs + OCE_mas_iceshelf, 'e', True )
+else :
+    prtFlux ( 'Bilan ocean :', -OCE_mas_emp_oce - OCE_mas_emp_ice + OCE_mas_runoffs + OCE_mas_iceberg + OCE_mas_calving + OCE_mas_iceshelf, 'e', True )
+
+
 echo     ('\n===>  Comparing ===>' ) 
 echo     ('  WFX OCE                     = -empmr + iceshelf                                            = {:12.5e} (kg) '.format ( -OCE_mas_empmr + OCE_mas_iceshelf) )
@@ -770,7 +807,7 @@
 echo ('                        = (dSEA_mas_wat + emp_oce + emp_ice - runoffs - iceshelf)*/abs(dSEA_mas_wat)      = {:12.1e} (-)  '.format ( (dSEA_mas_wat + OCE_mas_emp_oce + OCE_mas_emp_ice - OCE_mas_runoffs - OCE_mas_iceshelf)/abs(dSEA_mas_wat) ) )
 
-prtFlux ('   Leak OCE             ', ( dOCE_mas_wat + OCE_mas_empmr - OCE_mas_iceshelf) , 'e' )
-prtFlux ('   Leak ICE+SNW+PND     ', ( dICE_mas_wat + OCE_mas_emp_ice + OCE_mas_wfxice + OCE_mas_wfxsnw + ICE_mas_wfxpnd + ICE_mas_wfxsub_err ) , 'e' )
-prtFlux ('   Leak OCE+ICE+SNW+PND ',  ( dSEA_mas_wat + OCE_mas_emp_oce +OCE_mas_emp_ice - OCE_mas_runoffs - OCE_mas_iceshelf ) , 'e' )
+prtFlux ('   Leak OCE             ', ( dOCE_mas_wat + OCE_mas_empmr - OCE_mas_iceshelf) , 'e', True )
+prtFlux ('   Leak ICE+SNW+PND     ', ( dICE_mas_wat + OCE_mas_emp_ice + OCE_mas_wfxice + OCE_mas_wfxsnw + ICE_mas_wfxpnd + ICE_mas_wfxsub_err ) , 'e', True )
+prtFlux ('   Leak OCE+ICE+SNW+PND ',  ( dSEA_mas_wat + OCE_mas_emp_oce +OCE_mas_emp_ice - OCE_mas_runoffs - OCE_mas_iceshelf ) , 'e', True )
 
 
Index: TOOLS/WATER_BUDGET/WaterUtils.py
===================================================================
--- TOOLS/WATER_BUDGET/WaterUtils.py	(revision 6620)
+++ TOOLS/WATER_BUDGET/WaterUtils.py	(revision 6647)
@@ -70,6 +70,7 @@
 def unDefined (char) :
     '''True if a variable is not defined, or set to None'''
-    if char in locals () :
-        if locals()[char] == None : unDefined = True
+    if char in globals () :
+        if globals()[char] == None :
+                unDefined = True
         else            : unDefined = False
     else                : unDefined = True
@@ -79,5 +80,6 @@
     '''True if a variable is defined and not equal to None'''
     if char in globals () :
-        if globals()[char] == None : Defined = False
+        if globals()[char] == None :
+                Defined = False
         else            : Defined = True
     else                : Defined = False
Index: TOOLS/WATER_BUDGET/lmdz.py
===================================================================
--- TOOLS/WATER_BUDGET/lmdz.py	(revision 6620)
+++ TOOLS/WATER_BUDGET/lmdz.py	(revision 6647)
@@ -28,5 +28,5 @@
 __Date__     = "$Date$"
 __Revision__ = "$Revision$"
-__Id__       = "$Id: lmdz.py 6508 2023-06-13 10:58:38Z omamce $"
+__Id__       = "$Id: $"
 __HeadURL    = "$HeadURL$"
 
@@ -36,11 +36,11 @@
 except ImportError : pass
 
-#try    : import numba
-#except ImportError : pass
+try    : import numba
+except ImportError : pass
 
 rpi = np.pi ; rad = np.deg2rad (1.0) ; dar = np.rad2deg (1.0)
 
 
-def __math__ (tab) :
+def __mmath__ (tab) :
     '''
     Determines the type of tab : i.e. numpy or xarray
@@ -71,5 +71,5 @@
     
     '''
-    math = __math__ (tab)
+    math = __mmath__ (tab)
     if tab.shape[-1] == 1 : extend = tab
 
@@ -99,5 +99,5 @@
     return extend
 
-def interp1d (x, xp, yp, zdim='presnivs', verbose=False, method='linear') :
+def interp1d (x, xp, yp, zdim='presnivs', units=None, verbose=False, method='linear') :
     '''
     One-dimensionnal interpolation of a multi-dimensionnal field
@@ -118,5 +118,5 @@
 
        \!/ xp should be decreasing values along zdim axis \!/
-    '''    
+    '''
     # Get the number of dimension with dim==zdim
     axis = list(xp.dims).index(zdim)
@@ -128,22 +128,28 @@
     # Define the result array
     in_shape       = np.array (xp.shape)
-    if verbose : print ( 'in_shape    : ', in_shape   )
+    if verbose : print ( f'{in_shape=}' )
     ou_shape       = np.array (in_shape)
-    if verbose : print ( 'ou_shape    : ', ou_shape   )
+    if verbose : print ( f'{ou_shape=}' )
     ou_shape[axis] = nk_ou
     
     in_dims        = list (yp.dims)
-    if verbose : print ( 'in_dims     : ', in_dims    )
+    if verbose : print ( f'{in_dims=}' )
     ou_dims        = in_dims
-    if verbose : print ( 'ou_dims     : ', ou_dims    )
+  
     pdim           = x.dims[0]
     ou_dims[axis]  = pdim
 
     new_coords = []
-    for coord in yp.dims :
-        if coord == zdim : new_coords.append (x.coords[pdim].values)
-        else             : new_coords.append (yp.coords[coord].values)
+    for i, dim in enumerate (yp.dims) :
+        if dim == zdim :
+            ou_dims[i] = x.dims[0]
+            if units != None : yp[dim].attrs['units'] = units
+            new_coords.append (x             .values)
+        else :
+            new_coords.append (yp.coords[dim].values)
    
-    if verbose : print ( 'new_coords  : ', new_coords )
+    if verbose :
+        print ( f'{ou_dims   =}'     )
+        print ( f'{new_coords=}' )
         
     ou_tab = xr.DataArray (np.empty (ou_shape), dims=ou_dims, coords=new_coords)
@@ -159,38 +165,40 @@
 
     # Optimized (pre-compiled) interpolation loop
-    #@numba.jit(nopython=True)
-    def __interp (nk_ou, x, xp, yp, result) :
+    #@numba.jit (nopython=True)
+    def __interp (nk_ou, x, xp, yp) :
         # Interpolate
-        for k in np.arange (nk_ou) :
-            # Find index of the just above level
-            idk1 = np.minimum ( (x[k]-xp), 0.).argmax (dim=zdim)
-            idk2 = idk1 - 1
-            idk2 = np.maximum (idk2, 0)
-            
-            x1   = xp[{zdim:idk1}]
-            x2   = xp[{zdim:idk2}]
-            
-            dx1  = x[k] - x1
-            dx2  = x2   - x[k]
-            dx   = x2   - x1
-            dx1  = dx1/dx ; dx2 = dx2/dx
-            
-            y1   = yp[{zdim:idk1}]
-            y2   = yp[{zdim:idk2}]
-            
-            if 'linear'  in method : 
-                result = (dx1*y2 + dx2*y1)
-            if 'log'     in method :
-                if yp_min > 0. : 
-                    result = np.power(y2, dx1) * np.power(y1, dx2)
-                if yp_max < 0. :
-                    result = -np.power(-y2, dx1) * np.power(-y1, dx2)
-            if 'nearest' in method :
-                result = xr.where ( dx2>=dx1, y1, y2)
+        # Find index of the just above level
+        idk1 = np.minimum ( (x-xp), 0.).argmax (dim=zdim)
+        idk2 = idk1 - 1
+        idk2 = np.maximum (idk2, 0)
+        
+        x1   = xp[{zdim:idk1}]
+        x2   = xp[{zdim:idk2}]
+        
+        dx1  = x  - x1
+        dx2  = x2 - x
+        dx   = x2 - x1
+        dx1  = dx1/dx ; dx2 = dx2/dx
+        
+        y1   = yp[{zdim:idk1}]
+        y2   = yp[{zdim:idk2}]
+        
+        #print ( f'{k=} {idk1=} {idk2=} {x1=} {x2=} {dx=1} {dx2=} {y1=} {y2}' )
+        
+        if 'linear'  in method : 
+            result = (dx1*y2 + dx2*y1)
+        if 'log'     in method :
+            if yp_min > 0. : 
+                result = np.power(y2, dx1) * np.power(y1, dx2)
+            if yp_max < 0. :
+                result = -np.power(-y2, dx1) * np.power(-y1, dx2)
+        if 'nearest' in method :
+            result = xr.where ( dx2>=dx1, y1, y2)
                 
-            return result
-
-        result = __interp  (nk_ou, x, xp, yp, result)
-            
+        return result
+
+    for k in np.arange (nk_ou) :
+        result = __interp  (nk_ou, x[{pdim:k}], xp, yp)
+           
         # Put result in the final array
         ou_tab [{pdim:k}] = result
@@ -198,4 +206,25 @@
     return ou_tab.squeeze()
 
+def fixed_lon (lon, center_lon=0.0) :
+    '''
+    Returns corrected longitudes for nicer plots
+
+    lon        : longitudes of the grid. At least 1D.
+    center_lon : center longitude. Default=0.
+
+    Designed by Phil Pelson. See https://gist.github.com/pelson/79cf31ef324774c97ae7
+    '''
+    mmath = __mmath__ (lon)
+    
+    fixed_lon = lon.copy ()
+
+    fixed_lon = mmath.where (fixed_lon > center_lon+180., fixed_lon-360.0, fixed_lon)
+    fixed_lon = mmath.where (fixed_lon < center_lon-180., fixed_lon+360.0, fixed_lon)
+    
+    start = np.argmax (np.abs (np.diff (fixed_lon, axis=-1)) > 180., axis=-1)
+    fixed_lon [start+1:] += 360.
+
+    return fixed_lon
+
 def nord2sud (p2D) :
     '''
@@ -210,5 +239,5 @@
     From 1D (restart type) to 2D
     '''
-    math = __math__ (p1D)
+    math = __mmath__ (p1D)
 
     # Get the dimensions
@@ -244,9 +273,9 @@
     return p2D
 
-def geo2point ( p2D, cumulPoles=False, dim1D='cell', debug=False ) : 
+def geo2point ( p2D, cumulPoles=False, dim1D='points_physiques' ) : 
     '''
     From 2D (lat, lon) to 1D (points_phyiques)
     '''
-    math = __math__ (p2D)
+    math = __mmath__ (p2D)
     #
     # Get the dimension
@@ -260,7 +289,4 @@
 
     jpn = jpi*(jpj-2) + 2
-
-    if debug :
-        print ( f'{jpi=} {jpj=} {jpn=} {jpt=}' )
 
     if jpt == -1 :
@@ -281,5 +307,5 @@
     if math == xr :
         p1D       = xr.DataArray (p1D)
-        for attr in p2D.attrs :
+        for attr in p2D.attrs : 
             p1D.attrs[attr] = p2D.attrs[attr]
         p1D       = p1D.rename ( {p1D.dims[0]:p2D.dims[0], p1D.dims[-1]:dim1D} )
@@ -291,9 +317,9 @@
     return p1D
 
-def geo3point ( p3D, cumulPoles=False, dim1D='cell' ) : 
+def geo3point ( p3D, cumulPoles=False, dim1D='points_physiques' ) : 
     '''
     From 3D (lev, lat, lon) to 2D (lev, points_phyiques)
     '''
-    math = __math__ (p3D)
+    math = __mmath__ (p3D)
     #
     # Get the dimensions
